#pragma once
#include "Actor.h"
#include "ActorInterface_Private.h"
#include "WASCommand.h"

class CMessengerActor;
class CWASMyPage;
class CWASListBuddy;
class CWASListBuddyGroup;
class CWASListMember;
class CWASListNameSearch;
class CWASGetEmployeeInfo;
class CWASListMemberGroup;
class CWASListTenantDomain;
class CWASGetUserProfile;
class CWASUpdateBuddy;
class CWASSearchBuddy;
class CWASAddGroup;
class CWASDelGroup;
class CWASUpdateGroup;
class CWASUpdateGroupSortOrder;
class CWASRefreshTicket;
class CWASCheckClientNetwork;
class CWASProfileImage;
class CWASSetUserProfile;
class CWASSendNote;
class CWASUnreadNoteCount;
class CWASNoteSetReadStatus;
class CWASGetRecvNoteInfo;
class CWASDeleteAttachedFile;
class CWASDeleteNote;
class CWASGetAttatchID;
class CWASGetReplyBody;
class CWASGetTalkName;
class CWASMMCAccuseText;
class CWASGetTotalUsedCapa;
class CWASGetNewRoom;
class CWASGetMyRoomList;
class CWASListNotice;
class CWASListBanner;
class CWASGetHanatourCount;
class CWASListOutLink;
class CWASGetMailCount;
class CWASGetMailPreview;
class CWASGetCallHistory;
class CWASSetCallInfo;
class CWASSetCallMemo;
class CWASSearchCallHistory;
class CWASSMS;
class CWASSetLang;
class CWASGetLang;
class CWASChangeNotice;
class CWASCheckUpNotice;
class CWASGetMessages;
class CWASActor : public CActor, public IGTWASActor
{
public:
	CWASActor(CMessengerActor *pActor);
	~CWASActor(void);

	// For GTObject
protected:	
	virtual void OnReleaseObject(void) { delete this; }

public:
	//  WAS Observer Class   Ѵ.
	// 1. ܺο ϴ  Ŭ => IGTWASActorEvent
	// 2. ο ϴ  Ŭ => IGTWASActorEventPrivate
	// IGTWASActorEventPrivate  ϱ     Լ 3 Ѵ.
	void RegisterObserverEx(IGTWASActorEventPrivate *pOb)
	{
		m_observerPrivate.RegisterObserver(pOb);
		IGTWASActor::RegisterObserver(pOb);
	}
	void UnRegisterObserverEx(IGTWASActorEventPrivate *pOb)
	{
		m_observerPrivate.UnRegisterObserver(pOb);
		IGTWASActor::UnRegisterObserver(pOb);
	}
	void GetObserversEx(std::list<IGTWASActorEventPrivate *> *pOb)
	{
		m_observerPrivate.GetObservers(pOb);
	}

public:	
	virtual bool CancelRequest(trid_t trid);
	
	// ׳Ʈ 
			bool RequestTenantDomainList(LPCWSTR strTenant, trid_t *pTrid = NULL);
	virtual bool RequestGetTotalUsedCapa(trid_t *pTrid = NULL);

	// ģ 
	        bool RequestBuddyList(LPCWSTR strLangCode, int nCacheSerial, trid_t *pTrid = NULL);
	        bool RequestBuddyGroupList(trid_t *pTrid = NULL);	
			bool RequestMemberList(int nGroupType, LPCWSTR strParentGrpID, LPCWSTR strGrpID, LPCWSTR strLangCode, trid_t *pTrid = NULL);
			bool RequestNameSearchList(const NE_SEARCH_MEMBER_PARAM& searchParam, trid_t *pTrid = NULL);
			bool RequestEmplyeeInfo(LPCWSTR strEmpIDs, LPCWSTR strLangCode, NTRequestEmpInfoType reqEmpInfoType = reitSingleTrans, trid_t *pTrid = NULL, int nGroupID = -1);

			bool RequestMemberGroupList(int nGroupType, LPCWSTR CustcoID, LPCWSTR strTenant, LPCWSTR strLangCode, trid_t *pTrid = NULL);
			bool RequestMyPage(bool bFirstLogin, GTOSType eOSType, WSTRING &strLangCode, WSTRING &strTenantName, int nProfileSerial, int nInviteBuddySerial, int nSpecSerial, trid_t *pTrid = NULL);
	        bool RequestUpdateBuddy(vector< pair<wstring, int> > vecBuddy, int nNewGrpID, trid_t *pTrid);
	        bool RequestSearchBuddy(LPCWSTR strBuddyID, trid_t *pTrid = NULL);

		
			 
	virtual bool RequestGetUserProfile(LPCWSTR strUserID, trid_t *pTrid = NULL);
	virtual bool RequestSetMyUserProfile(const GT_USER_PROFILE_DATA &sInfo, trid_t *pTrid = NULL);



	// ׷ 
	        bool RequestAddGroup(LPCWSTR strGroupName, GTBuddyAddGroupType addGroupType, int nSortOrder = 0, trid_t *pTrid = NULL);
	        bool RequestDelGroup(int nGroupID, trid_t *pTrid = NULL);
	        bool RequestUpdateGroup(int nGroupID, const GT_BUDDY_GROUP_UPDATABLE_DATA &sInfo, trid_t *pTrid = NULL);
			bool RequestUpdateGroupSortOrder(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData, trid_t *pTrid = NULL);

	//  ̹ 
	        bool RequestProfileImageProfile(bool bUpload, const GT_PROFILE_IMAGE_DATA &sData, DWORD dwUserData1, DWORD dwUserData2, trid_t *pTrid = NULL);
	
	// äù 
	virtual bool RequestGetNewRoom(LPCTSTR pszCid, LPCTSTR pszCName, LPCTSTR pszBid, LPCTSTR pszBName, trid_t *pTrid = NULL);
	virtual bool RequestGetMyRoomList(LPCWSTR strLangCode, trid_t *pTrid = NULL);
	virtual bool RequestGetMessages(int nRoomId, int nJoinSeq, int nFromMsgNum, int nToMsgNum, int nSendSuccess, trid_t *pTrid = NULL);

	virtual bool RequestSendNote(NT_NOTE_SEND_DATA &sSendNoteData, trid_t *pTrid = NULL);
	virtual bool RequestUnreadNoteCount( trid_t *pTrid = NULL);
	virtual bool RequestNoteSetReadStatus( UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid = NULL);
	virtual bool RequestGetRecvNoteInfo( UINT64 nNoteID, NTReqNoteInfoType reqType, LPCSTR strLanguage, bool bIncludeToList, trid_t *pTrid = NULL);
	virtual bool RequestDelAttachedFile( LPCSTR strAttachID, int nIndex, trid_t *pTrid = NULL);
	virtual bool RequestDeleteNote( UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid = NULL);
	virtual bool RequestGetAttachID( trid_t *pTrid = NULL);
	virtual bool RequestGetReplyBody( LPCWSTR strWriteMode, UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid = NULL);
    
	// Ÿ
	virtual bool RequestGetTalkName(LPCTSTR strEmpIDs, trid_t *pTrid = NULL);
	        bool RequestRefreshTicket(trid_t *pTrid = NULL);
	virtual bool RequestCheckClientNetwork(trid_t *pTrid = NULL);
	
	virtual bool RequestListNotice(trid_t *pTrid = NULL);
	virtual bool RequestListBanner(trid_t *pTrid = NULL);
	virtual bool RequestGetHanatourCount(trid_t *pTrid = NULL);
	virtual bool RequestListOutLink(trid_t *pTrid = NULL);

	virtual bool RequestMailCount(trid_t *pTrid = NULL);
	virtual bool RequestMailPreview(ULONGLONG ulMailSerial, trid_t *pTrid = NULL);

	virtual bool RequestCallHistory(NTCallType eCallType, LPCWSTR strLangCode, trid_t *pTrid = NULL);
	virtual bool RequestSetCallInfo(NE_CALL_DATA &sCallData, trid_t *pTrid = NULL);
	virtual bool RequestSearchCallHistory(NTCallType eCallType, LPCWSTR strSearchWord, LPCWSTR strLangCode, trid_t *pTrid = NULL);
	virtual	bool RequestSetCallMemo(int nCallSeq, LPCWSTR strMemo, trid_t *pTrid = NULL);

	virtual bool RequestSMS(LPCWSTR strContent,LPCWSTR strToTelNo, LPCWSTR strFromTelNo, trid_t *pTrid);

	virtual bool RequestSetLanguage(LPCWSTR strLanguage, trid_t *pTrid);

	virtual bool RequestGetLanguage(trid_t *pTrid);

	virtual bool RequestChangeNotice(LPCWSTR strURL, LPCWSTR strCorp, trid_t *pTrid = NULL);

	virtual bool RequestCheckUpNotice(LPCWSTR strURL, trid_t *pTrid = NULL);

	virtual const FILE_UPLOAD_RESULT_DATA* RequestUploadFileParsing(std::string &strJson);

	virtual LPCWSTR GetLastErrorString(trid_t trid);
	
	virtual bool GetPenaltyResultInfo(trid_t trid, GT_PENALTY_RESULT_DATA &sPenaltyResult);
	virtual bool GetCacheResultInfo(trid_t trid, GT_CACHE_SERIAL_DATA &sResult);
	virtual bool GetContentProgressInfo(trid_t trid, size_t &totalSize, size_t &currentSize);
	virtual void SetWASServerAddress(const WSTRING& strServerAddr);
	virtual LPCWSTR GetWASServerAddress();
public:
	virtual void OnGTManagementEvent_DeleteActor(CActor *pActor);

private:
	bool _HasLoginTicket(void);

	// For internal
public:
	CMessengerActor *GetMessengerActor(void) { return m_pMessengerActor; }
	bool ReleaseCommand(trid_t trid);
	bool DeleteCommand(trid_t trid);
	bool CancelCommand(trid_t trid);
	void DeleteWASCommand(CWASCommand *pCommand);
	void SavePenaltyResult(trid_t trid, const P_GT_PENALTY_RESULT_DATA &sResult);
	void SaveCacheResult(trid_t trid, const GT_CACHE_SERIAL_DATA &sResult);
	void DeleteCacheResult(trid_t trid);
	void SetAlwaysNewAuthTicketMode(bool bEnable)
	{
		m_bAlwaysNewAuthTicketMode = bEnable;
	}


private:
	typedef std::map< trid_t , CWASCommand *> wascmdmap_t;
	typedef std::map< trid_t , P_GT_PENALTY_RESULT_DATA> waspenaltyresultmap_t;
	typedef std::map< trid_t , GT_CACHE_SERIAL_DATA> wascacheresultmap_t;

	bool m_bAlwaysNewAuthTicketMode;
	
	//p_mobileusersynclist_t	m_vecMobileUserSyncList;
	
	wascmdmap_t				m_mapCommand; 
	wascmdmap_t				m_mapCommandForDynamic;
	waspenaltyresultmap_t	m_mapPenaltyResult;
	wascacheresultmap_t		m_mapCacheResult;
	CGTObserved<IGTWASActorEventPrivate>	m_observerPrivate;
	FILE_UPLOAD_RESULT_DATA m_fileUploadData;

	CMessengerActor	*				m_pMessengerActor;

	CWASMyPage *					m_pWASMyPage;
	CWASListBuddy *					m_pWASListBuddy;
	CWASListBuddyGroup *			m_pWASListBuddyGroup;
	CWASListMember *				m_pWASListMember;
	CWASListNameSearch*				m_pWASListNameSearch;
	CWASGetEmployeeInfo*			m_pWASGetEmployeeInfo;
	CWASGetEmployeeInfo*			m_pWASPrivateGetEmployeeInfo;
	CWASListMemberGroup *			m_pWASListMemberGroup;
	CWASListTenantDomain *			m_pWASListTenantDomain;
	CWASGetUserProfile *			m_pWASGetUserProfile;
	CWASSetUserProfile *			m_pWASSetUserProfile;
	CWASUpdateBuddy *				m_pWASUpdateBuddy;
	CWASSearchBuddy *				m_pWASSearchBuddy;	
	CWASAddGroup *					m_pWASAddGroup;	
	CWASDelGroup *					m_pWASDelGroup;		
	CWASUpdateGroup *				m_pWASUpdateGroup;
	CWASUpdateGroupSortOrder *		m_pWasUpdateGroupSortOrder;
	CWASRefreshTicket *				m_pWASRefreshTicket;
	CWASCheckClientNetwork *		m_pWASCheckClientNetwork;
	//CWASSendNote *					m_pWASSendNote;
	CWASUnreadNoteCount *			m_pWASUnreadNoteCount;
	CWASNoteSetReadStatus *			m_pWASNoteSetReadStatus;
	CWASDeleteAttachedFile *		m_pWASDeleteAttachedFile;
	CWASDeleteNote *				m_pWASDeleteNote;
	CWASGetTalkName *				m_pWASGetTalkName;
	CWASGetTotalUsedCapa *			m_pWASGetTotalUsedCapa;
	//CWASGetNewRoom *				m_pWASGetNewRoom;
	CWASGetMyRoomList *				m_pWASGetMyRoomList;
	CWASListNotice *				m_pWASListNotice;
	CWASListBanner *				m_pWASListBanner;
	CWASGetHanatourCount *			m_pWASGetHanatourCount;
	CWASListOutLink *				m_pWASListOutLink;
	CWASGetMailCount *				m_pWASGetMailCount;
	CWASGetMailPreview *			m_pWASGetMailPreview;
	CWASSMS *						m_pWASSMS;
	CWASSetLang *					m_pWASSetLang;
	CWASGetLang *					m_pWASGetLang;
	CWASGetCallHistory *			m_pWASGetCallHistory;
	CWASSetCallInfo *				m_pWASSetCallInfo;
	CWASSearchCallHistory *			m_pWASSearchCallHistory;
	CWASSetCallMemo *				m_pWASSetCallMemo;
	CWASChangeNotice *				m_pWASChangeNotice;
	CWASCheckUpNotice *				m_pWASCheckUpNotice;
	WSTRING							m_strServerAddr;
};
